/*
 * PanelTransferable.java
 *
 * Created on January 26, 2006, 9:29 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package it.businesslogic.ireport.gui.docking;
import java.awt.datatransfer.*;

/**
 *
 * @author gtoffoli
 */
public class PanelTransferable implements Transferable, ClipboardOwner {
    
    Object obj;
    java.awt.datatransfer.DataFlavor thisFlavor;
    /** Creates a new instance of TransferableObject */
    public PanelTransferable(Object obj) {
        this.obj = obj;
        thisFlavor = new java.awt.datatransfer.DataFlavor(obj.getClass(), obj.getClass().getName());
    }
    
    public Object getTransferData(java.awt.datatransfer.DataFlavor flavor) throws java.awt.datatransfer.UnsupportedFlavorException, java.io.IOException {
        if (flavor.equals( thisFlavor ))
        {
            return obj;
       }
       // GDN new code start
       else
       if (flavor.equals( java.awt.datatransfer.DataFlavor.stringFlavor )) {
            return new String();    // anything non-null
       }
       else
       // GDN new code end
            return null;
    }
    
    public java.awt.datatransfer.DataFlavor[] getTransferDataFlavors() {
        // GDN new code start
        java.awt.datatransfer.DataFlavor stringFlavor = java.awt.datatransfer.DataFlavor.stringFlavor;
        return new java.awt.datatransfer.DataFlavor[] { thisFlavor,
                                                        stringFlavor };
        // GDN new code end
        
        // GDN comment out-->return new java.awt.datatransfer.DataFlavor[]{thisFlavor};
    }
    
    public boolean isDataFlavorSupported(java.awt.datatransfer.DataFlavor flavor) {
// GDN comment out
//        if (flavor != null && flavor.equals( thisFlavor ))
//        {
//            return true;
//        }
//        
//        return false;
// GDN comment out
        // GDN new code begin
        if (flavor == null)
            return false;
        else
        if (flavor.equals( thisFlavor ))
            return true;
        else
        if (flavor.equals( java.awt.datatransfer.DataFlavor.stringFlavor ))
            return true;
        else
            return false;
        // GDN new code end
    }

    public void lostOwnership(Clipboard clipboard, Transferable contents) {
    }
}
